set define off
set verify off
set serveroutput on size 1000000
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end; 
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040000 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,35260313093202493));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2010.05.13');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,117);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/process_type/com_skillbuilders_sbpp_geocode
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'PROCESS TYPE'
 ,p_name => 'COM_SKILLBUILDERS_SBPP_GEOCODE'
 ,p_display_name => 'SkillBuilders Geocode'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION sbpp_geocode_execution ('||chr(10)||
'   p_process IN APEX_PLUGIN.T_PROCESS,'||chr(10)||
'   p_plugin  IN APEX_PLUGIN.T_PLUGIN '||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN APEX_PLUGIN.T_PROCESS_EXEC_RESULT'||chr(10)||
''||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_retval             APEX_PLUGIN.T_PROCESS_EXEC_RESULT;'||chr(10)||
'   l_yahoo_appid        VARCHAR2(500) := p_plugin.attribute_01;'||chr(10)||
'   l_addr_format        VARCHAR2(30) := NVL(p_process.attribute_01,''FREE_FORM'');'||chr(10)||
'   l_free_form_item     VARCHAR2('||
'100) := p_process.attribute_02;'||chr(10)||
'   l_line1_item         VARCHAR2(100) := p_process.attribute_03;'||chr(10)||
'   l_line2_item         VARCHAR2(100) := p_process.attribute_04;'||chr(10)||
'   l_line3_item         VARCHAR2(100) := p_process.attribute_05;'||chr(10)||
'   l_lat_item           VARCHAR2(100) := p_process.attribute_06;'||chr(10)||
'   l_long_item          VARCHAR2(100) := p_process.attribute_07;'||chr(10)||
'   l_free_from_item_val VARCHAR2(32767);'||chr(10)||
'  '||
' l_line1_item_val     VARCHAR2(32767);'||chr(10)||
'   l_line2_item_val     VARCHAR2(32767);'||chr(10)||
'   l_line3_item_val     VARCHAR2(32767);'||chr(10)||
'   l_rest_result        XMLTYPE;'||chr(10)||
'   l_parm_name_list     WWV_FLOW_GLOBAL.VC_ARR2;'||chr(10)||
'   l_parm_value_list    WWV_FLOW_GLOBAL.VC_ARR2;'||chr(10)||
'   l_error              VARCHAR2(32767);'||chr(10)||
'   l_found_count        PLS_INTEGER;'||chr(10)||
'   '||chr(10)||
'   PROCEDURE clear_lat_long'||chr(10)||
'   IS'||chr(10)||
'   BEGIN'||chr(10)||
'      apex_util.set_ses'||
'sion_state(l_lat_item, '''');'||chr(10)||
'      apex_util.set_session_state(l_long_item, '''');'||chr(10)||
'   END;'||chr(10)||
'   '||chr(10)||
'   PROCEDURE make_ws_request'||chr(10)||
'   IS'||chr(10)||
'   BEGIN'||chr(10)||
'      l_rest_result := xmltype('||chr(10)||
'         apex_web_service.make_rest_request('||chr(10)||
'            p_url         => ''http://where.yahooapis.com/geocode'','||chr(10)||
'            p_http_method => ''GET'', '||chr(10)||
'            p_parm_name   => l_parm_name_list,'||chr(10)||
'            p_parm_value  => l_parm_'||
'value_list'||chr(10)||
'         )'||chr(10)||
'      );'||chr(10)||
'      '||chr(10)||
'      IF l_rest_result.extract(''//Error/text()'').getnumberval() = 0'||chr(10)||
'      THEN'||chr(10)||
'         l_found_count := l_rest_result.extract(''//Found/text()'').getnumberval();'||chr(10)||
'         '||chr(10)||
'         IF l_found_count = 1'||chr(10)||
'         THEN'||chr(10)||
'            IF l_rest_result.extract(''//Result/quality/text()'').getstringval() >= 87 --Address match with street match (or better) '||chr(10)||
'            THE'||
'N'||chr(10)||
'               apex_util.set_session_state(l_lat_item, l_rest_result.extract(''//Result/latitude/text()'').getstringval());'||chr(10)||
'               apex_util.set_session_state(l_long_item, l_rest_result.extract(''//Result/longitude/text()'').getstringval());'||chr(10)||
'            ELSE'||chr(10)||
'               clear_lat_long;'||chr(10)||
'            END IF;'||chr(10)||
'         ELSIF l_found_count = 0 '||chr(10)||
'         THEN'||chr(10)||
'            clear_lat_long;'||chr(10)||
'        '||
' ELSIF l_found_count > 1'||chr(10)||
'         THEN'||chr(10)||
'            RAISE_APPLICATION_ERROR(-20001, ''Geocode result error: multiple addresses found.'');'||chr(10)||
'         END IF;'||chr(10)||
'      ELSE'||chr(10)||
'         l_error := l_rest_result.extract(''//ErrorMessage/text()'').getstringval();'||chr(10)||
'         '||chr(10)||
'         RAISE_APPLICATION_ERROR(-20001, ''Yahoo error: '' || l_error);'||chr(10)||
'      END IF;'||chr(10)||
'   END;'||chr(10)||
'   '||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   IF apex_application.g_debug '||chr(10)||
'   THEN'||chr(10)||
' '||
'     apex_plugin_util.debug_process('||chr(10)||
'         p_plugin  => p_plugin,'||chr(10)||
'         p_process => p_process'||chr(10)||
'      );'||chr(10)||
'   END IF;'||chr(10)||
'   '||chr(10)||
'   l_parm_name_list(1) := ''appid'';'||chr(10)||
'   l_parm_value_list(1) := l_yahoo_appid;'||chr(10)||
'   l_parm_name_list(2) := ''flags'';'||chr(10)||
'   l_parm_value_list(2) := ''C'';'||chr(10)||
'   '||chr(10)||
'   IF l_addr_format = ''FREE_FORM'''||chr(10)||
'   THEN'||chr(10)||
'      l_free_from_item_val := v(l_free_form_item);'||chr(10)||
'      '||chr(10)||
'      IF l_free_from_item_v'||
'al IS NOT NULL'||chr(10)||
'      THEN'||chr(10)||
'         l_parm_name_list(3) := ''location'';'||chr(10)||
'         l_parm_value_list(3) := REPLACE(REPLACE(l_free_from_item_val, CHR(13)||CHR(10), '' ''), CHR(10), '' '');'||chr(10)||
'         '||chr(10)||
'         make_ws_request;'||chr(10)||
'      ELSE'||chr(10)||
'         clear_lat_long;'||chr(10)||
'      END IF;'||chr(10)||
'      '||chr(10)||
'   ELSIF l_addr_format = ''MULTI_LINE'''||chr(10)||
'   THEN'||chr(10)||
'      l_line1_item_val := v(l_line1_item);'||chr(10)||
'      l_line2_item_val := v(l_line2_it'||
'em);'||chr(10)||
'      '||chr(10)||
'      IF l_line1_item_val IS NOT NULL '||chr(10)||
'         AND l_line2_item_val IS NOT NULL'||chr(10)||
'      THEN'||chr(10)||
'         l_parm_name_list(3) := ''line1'';'||chr(10)||
'         l_parm_value_list(3) := l_line1_item_val;'||chr(10)||
'         l_parm_name_list(4) := ''line2'';'||chr(10)||
'         l_parm_value_list(4) := l_line2_item_val;'||chr(10)||
'         '||chr(10)||
'         l_line3_item_val := v(l_line3_item);'||chr(10)||
'         '||chr(10)||
'         IF l_line3_item_val IS NOT NULL'||chr(10)||
'     '||
'    THEN'||chr(10)||
'            l_parm_name_list(5) := ''line3'';'||chr(10)||
'            l_parm_value_list(5) := l_line3_item_val;'||chr(10)||
'         END IF;'||chr(10)||
'         '||chr(10)||
'         make_ws_request;'||chr(10)||
'      ELSE'||chr(10)||
'         clear_lat_long;'||chr(10)||
'      END IF;'||chr(10)||
'   END IF;'||chr(10)||
'   '||chr(10)||
'   RETURN l_retval;'||chr(10)||
''||chr(10)||
'END sbpp_geocode_execution;'
 ,p_execution_function => 'sbpp_geocode_execution'
 ,p_attribute_01 => 'GVWr7nLV34EonGdS.z.T3aqL6flZphTHb3RtoiDYk_.1BK.ryjNHJaxHuzxOJ3lH8bcz4TI1Np_Pre.7uC.w7w4bPE9rdzA-'
 ,p_help_text => '<br />'||chr(10)||
''
 ,p_version_identifier => '1.0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5644812477089771 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Yahoo Application ID'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_display_length => 100
 ,p_max_length => 150
 ,p_is_translatable => false
 ,p_help_text => 'A Yahoo Application ID is required for this plug-in to work. Populate this setting with the Yahoo Application ID supplied to you from Yahoo. If you do not have a Yahoo Application ID you can get one here: https://developer.apps.yahoo.com/wsregapp/'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Address Format'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'FREE_FORM'
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting the control which address format is used when making the web service call. Currently only Free-form and Multi-line Formats are supported. A future release will support the more precise Full-Parsed Format. In the meantime a workaround can be accomplished by taking values from multiple items and concatenating them together into a single item (does not have to be displayed). Then the single item can be used with the Free-form mode.'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 5638414050853706 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Free-form'
 ,p_return_value => 'FREE_FORM'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 5638819937855375 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Multi-line'
 ,p_return_value => 'MULTI_LINE'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5639222492865629 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Free-form Format Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'FREE_FORM'
 ,p_help_text => 'Use this setting to specify the name of the item that will contain a free-form address. This item is required when the Address Format is set to Free-form.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5639710503871576 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Line 1 (address) Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'MULTI_LINE'
 ,p_help_text => 'Use this setting to specify the name of the item that will contain Line 1 of a multi-line address. This item is required when the Address Format is set to Multi-line.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5640320545874457 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Line 2 (city/state/zip) Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'MULTI_LINE'
 ,p_help_text => 'Use this setting to specify the name of the item that will contain Line 2 of a multi-line address. This item is required when the Address Format is set to Multi-line.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5640901283878370 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Line 3 (if any) Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => false
 ,p_is_translatable => false
 ,p_depending_on_attribute_id => 5637808855852218 + wwv_flow_api.g_id_offset
 ,p_depending_on_condition_type => 'EQUALS'
 ,p_depending_on_expression => 'MULTI_LINE'
 ,p_help_text => 'Use this setting to specify the name of the item that will contain Line 3 of a multi-line address. This item is not required and need only be used for addresses in countries that use it.'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5642111204947465 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 6
 ,p_display_sequence => 60
 ,p_prompt => 'Return Latitude into Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify the name of the item that the latitude value should be returned into. If an address match is not found, based on the supplied address, the value of the item will be set to NULL (or cleared out).'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5642719862950014 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 9209229456689559020 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 7
 ,p_display_sequence => 70
 ,p_prompt => 'Return Longitude into Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
 ,p_help_text => 'Use this setting to specify the name of the item that the longitude value should be returned into. If an address match is not found, based on the supplied address, the value of the item will be set to NULL (or cleared out).'
  );
null;
 
end;
/

commit;
begin 
execute immediate 'begin dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
prompt  ...done
